
//   ██████╗ ██████╗ ██╗      ██████╗ ███╗   ██╗██╗   ██╗
//  ██╔════╝██╔═══██╗██║     ██╔═══██╗████╗  ██║╚██╗ ██╔╝
//  ██║     ██║   ██║██║     ██║   ██║██╔██╗ ██║ ╚████╔╝
//  ██║     ██║   ██║██║     ██║   ██║██║╚██╗██║  ╚██╔╝
//  ╚██████╗╚██████╔╝███████╗╚██████╔╝██║ ╚████║   ██║
//   ╚═════╝ ╚═════╝ ╚══════╝ ╚═════╝ ╚═╝  ╚═══╝   ╚═╝
//
//              ███████╗██╗  ██╗██╗██████╗
//              ██╔════╝██║  ██║██║██╔══██╗
//              ███████╗███████║██║██████╔╝
//              ╚════██║██╔══██║██║██╔═══╝
//              ███████║██║  ██║██║██║
//              ╚══════╝╚═╝  ╚═╝╚═╝╚═╝

var cs = {};

function random(min, max) {
  return Math.floor(Math.random() * (1 + max - min) + min);
}

function either(...arg) {
  const m = arg.length - 1;
  return arg[random(0, m)];
}

$.when($.ready).then(function () {
  setTimeout(() => cs.menuPage(), 900);
});

cs.display = function(page) {
  const out = (cs.pages[page] == null) ? `ERROR: ${page} missing` : cs.pages[page];
  $("#main").empty().append(out);
  $("#main").animate({ scrollTop: 0 }, "fast");
  if (page.slice(0,2) !== "XX") {
    cs.shipDisplay();
  }
};



cs.status = {
  upgrades: [0, 0, 0, 0, 0],
  atmo: 100,
  grav: 100,
  temp: 100,
  water: 100,
  rsrc: 100,
  probes: 10,
  colonists: 5000,
  landing: 100,
  builder: 100,
  supplies: 100,
  culture: 100,
  science: 100,
};

/*
#996600
#ff3300
#ff9900
#ffcc00
#99cc00
#009933
*/

cs.types = {
  atmo: [
    "None",
    "Low Pressure",
    "High CO2",
    "Toxic",
    "High O2",
    "Dense",
    "Breathable",
  ],
  atmoD: [
    "The planet has next to no atmosphere, meaning that going outside would require a pressure suit.",
    "The planet's atmosphere is far too thin to breathe, but there is enough pressure that a bulky pressure suit isn't necessary for brief periods outside.",
    "The planet has a high percentage of CO2 in the air, so colonists will require a full mask and air tanks outdoors.",
    "The planet's atmosphere contains toxic trace elements that must be filtered out to breath outside.",
    "The planet's atmosphere contains a high level of oxygen, greatly increasing the danger of fires and enhancing corrosion of equipment.",
    "The planet's atmosphere is particularly dense but is otherwise breathable, though long-term health consequences are possible.",
    "The planet's atmosphere is remarkably similar to Earth's, with a breathable mix of gasses.",
  ],
  atmoC: [
    "#ff3300",
    "#ff9900",
    "#ff9900",
    "#ff9900",
    "#ffcc00",
    "#99cc00",
    "#009933",
  ],
  atmoP: [
    1,
    2,
    3,
    4,
    6,
    7,
    8,
  ],
  grav: [
    "Very High",
    "High",
    "Very Low",
    "Low",
    "Above Normal",
    "Below Normal",
    "Normal",
  ],
  gravD: [
    "The planet's dense nature and large size cause gravity to be significantly higher than on Earth. Colonists will require extensive modification to live on the surface.",
    "The planet's higher mass means that gravity is considerably higher than on Earth. Colonists will require modification in order to be productive.",
    "The planet's small size and lower density causes gravity to be significantly lower than on Earth. Colonists will likely experience long-term health complications. Children will experience developmental difficulty.",
    "The planet's low mass means that gravity is considerably lower than on Earth. Children are likely to experience developmental difficulty.",
    "The planet's gravity is somewhat higher than Earth's, making manual labor particularly exhausting.",
    "The planet's gravity is somewhat lower than Earth's, making manual labor easier.",
    "The planet's gravity is very similar to Earth's."
  ],
  gravC: [
    "#ff3300",
    "#ff3300",
    "#ffcc00",
    "#ffcc00",
    "#99cc00",
    "#009933",
    "#009933",
  ],
  gravP: [
    1,
    2,
    2,
    4,
    6,
    8,
    7,
  ],
  temp: [
    "Extremely Hot",
    "Extremely Cold",
    "Very Hot",
    "Very Cold",
    "Unstable",
    "Hot",
    "Cold",
    "Comfortable",
  ],
  tempD: [
    "The temperature on the surface is extremely hot, enough to melt some metals.",
    "The temperature on the surface is extremely cold, causing molecular gasses to precipitate or freeze.",
    "The temperature on the surface is very hot. Colonists will require environmental suits to go outside.",
    "The temperature on the surface is very cold. Colonists will require heavy thermal gear while outside.",
    "The temperature on the surface is unstable thanks to an elliptical orbit. Temperatures range from very hot at the periapsis to very cold at the apoapsis.",
    "The temperature on the surface is hot, with temperatures similar to Earth deserts at higher latitudes.",
    "The temperature on the surface is cold, with temperatures similar to the Arctic near the equator.",
    "The temperature range on the surface is similar to Earth.",
  ],
  tempC: [
    "#ff3300",
    "#ff3300",
    "#ff9900",
    "#ff9900",
    "#ffcc00",
    "#ffcc00",
    "#ffcc00",
    "#009933",
  ],
  tempP: [
    1,
    2,
    3,
    3,
    5,
    6,
    6,
    8,
  ],
  water: [
    "Trace",
    "Very Limited",
    "Limited",
    "Toxic",
    "Ocean World",
    "Salt Lakes",
    "Lakes",
    "Archipelago",
    "Oceans",
  ],
  waterD: [
    "The planet has practically no water.",
    "The planet has a very limited amount of water, most of which require intensive and inefficient methods to collect.",
    "The planet has a limited supply of water, most of which is trapped beneath the surface or frozen at the poles.",
    "The planet's water contains a high ratio of deuterium as well as other radioactive or toxic elements.",
    "The planet is an ocean world, with a single vast ocean covering the surface.",
    "The planet's liquid water exists in some small salt lakes, without much of a water cycle. Water will have to be desalinated to be used.",
    "The planet has liquid water, but does not have enough for oceans; instead it has a collection of large lakes.",
    "The planet's surface is almost entirely water, with a smattering of islands found in more geologically active areas.",
    "The planet has a similar ratio of land to water as found on Earth.",
  ],
  waterC: [
    "#ff3300",
    "#ff9900",
    "#ff9900",
    "#ff9900",
    "#ff9900",
    "#ffcc00",
    "#ffcc00",
    "#99cc00",
    "#009933",
  ],
  waterP: [
    1,
    2,
    3,
    4,
    5,
    5,
    7,
    7,
    8,
  ],
  rsrc: [
    "Barren",
    "Inaccessible",
    "Very Low",
    "Low",
    "Sufficient",
    "Plentiful",
  ],
  rsrcD: [
    "The planet's crust is extremely metal poor, with few of the elements necessary for a modern civilization.",
    "The planet's crust is very poor in metals, and recovering them is impossible given the available equipment.",
    "The planet's crust is very poor in metals, and most of the limited metals would require extensive mining efforts to recover small yields.",
    "The planet's crust is poor in metals, most notably rare-earth metals used in modern alloys and batteries.",
    "The planet's crust is somewhat poor in metals compared to Earth, but the deposits are untapped and available with basic mining techniques.",
    "The planet's crust has plenty of metals, and is similar to Earth before mankind began harvesting them. Basic metals are available without the need for mining.",

  ],
  rsrcC: [
    "#ff3300",
    "#ff9900",
    "#ff9900",
    "#ffcc00",
    "#99cc00",
    "#009933",
  ],
  rsrcP: [
    1,
    2,
    3,
    4,
    5,
    6,
  ],
  plant: [
    "None",
    "Infectious",
    "Toxic",
    "Limited",
    "Harmless",
    "Edible",
  ],
  plantD: [
    "The planet harbors no plantlife whatsoever.",
    "The planet is home to a unique plant analogue, which would likely be very difficult to overcome for human needs.",
    "The planet's plantlife has a unique biology that makes them universally toxic to humans, and native plantlife will have to be cleared away from any human settlement.",
    "There is only limited plantlife on the planet, and large swaths of the surface remain barren.",
    "The planet's plantlife isn't compatible with human biology. While it is poisonous to consume, it is generally harmless otherwise.",
    "The planet's plantlife is biologically similar to Earth's, and there seems to be some edible species.",

  ],
  plantC: [
    "#ff3300",
    "#ff3300",
    "#ff9900",
    "#ffcc00",
    "#99cc00",
    "#009933",
  ],
  plantP: [
    3,
    2,
    1,
    3,
    5,
    8,
  ],
  geo: [
    "Highly Volcanic",
    "Seismic",
    "Unstable Moon",
    "Asteroids",
    "Nemisis Star",
    "no Magnetosphere",
    "No Ozone",
    "Normal",
  ],
  geoD: [
    "The planet is highly volcanic, with numerous volcanoes and geothermal features on the surface. Large eruptions seem to be a common occurrence.",
    "The planet has a comparatively fragile crust, with numerous faster-moving plates. Most areas are subject to earthquakes, and areas near faults experience frequent and powerful quakes.",
    "The planet has a moon with an unstable orbit. While it won't happen for many years, the moon will eventually break apart from tidal forces. This will cause a cataclysmic event as fragments rain down on the planet below.",
    "The orbital space surrounding the planet is dense with captured asteroid material, ranging in size from a grain of sand to the size of a large house. While landing will be possible, it will be nearly impossible to deploy satellites.",
    "This star system is an unusual binary system, with a brown dwarf star in a distant orbit. The star's orbit is on a different plane than the system's planets, causing regular disturbances to the system's oort cloud. The planet receives a much larger than normal number of comet and asteroid impacts.",
    "The planet's core generates only a weak magnetic field, leaving the planet open to radiation from the system's star.",
    "The planet's atmosphere has never developed an ozone layer, leaving the surface exposed to much higher intensity UV radiation.",
    "No geological or astrological anomalies detected."
  ],
  geoC: [
    "#ff9900",
    "#ff9900",
    "#ff9900",
    "#ff9900",
    "#ff9900",
    "#ffcc00",
    "#ffcc00",
    "#009933",
  ],
  geoP: [
    0.6,
    0.8,
    0.5,
    0.9,
    0.6,
    0.9,
    1,
    1.1,
  ],
  animal: [
    "None",
    "Infesting",
    "Deadly",
    "Dangerous",
    "Limited",
    "Harmless",
    "Useful"
  ],
  animalD: [
    "No animal life was detected on the planet.",
    "The planet is home to an unexpected animal analogue, which appears to be uniquely suited to feeding on Earth biology.",
    "The planet's animals have unique biological traits that make them uniquely hazardous to Earth life.",
    "The planet's animals include some species of large predators which would likely be aggressive to humans.",
    "The planet has only limited animal life, primarily in the form of insect analogues.",
    "The planet has fairly benign animal life, however their unique biology means that they can't be used for food.",
    "The planet has a diverse range of animal life, with potential to use some species for food or even as beasts of burden.",
  ],
  animalC: [
    "#ff3300",
    "#ff3300",
    "#ff3300",
    "#ff9900",
    "#ffcc00",
    "#99cc00",
    "#009933",
  ],
  animalP: [
    1,
    0.8,
    0.9,
    1,
    1.1,
    1.2,
    1.5,
  ],
  alien: [
    "Paleo",
    "Stone Age",
    "Bronze Age",
    "Iron Age",
    "Industrial Age",
    "Modern Age",
    "High Tech Age",
    "Post Scarcity",
    "None",
  ],
  alienD: [
    "There is a primitive but intelligent species that hasn't formed any sort of civilization yet.",
    "There is a primitive but intelligent species that has discovered agriculture and has started forming larger social groups.",
    "There is an intelligent species that as discovered agriculture and metalurgy, and lives in a number of citystates.",
    "There is an intelligent species that form several civilizations on the planet, arranged into several iron-age nations.",
    "There is an intelligent species on the planet that has formed large nations and is in the middle of an industrial revolution.",
    "There is an intelligent species that has settled across most of the planet, they have a technology level similar to Earth of the mid 20th century.",
    "There is an intelligent species living on the planet that seems to have a level of technology similar to that of Earth before the plague.",
    "There is an advanced species of intelligent life living on the planet, with technology beyond Earth's.",
    "none",
  ],
  alienP: [
      1.2,
      1.3,
      1,
      0.9,
      0.8,
      1,
      1.4,
      1.5,
      1,
  ],
  bonus: [
    "Extensive Caves",
    "High-Tech Ruins",
    "Deadly Ruins",
    "Inspiring Ruins",
    "Extremely Fertile",
    "Dead Soil",
    "Scenic Planet",
    "Ugly Planet",
    "Gentle Climate",
    "Unstable Climate",
    "None",
  ],
  bonusD: [
    "Many areas of the planet's crust are riddled with large cave networks.",
    "The probe discovered the ruins of a fairly advanced civilization scattered around the planet. Some of them may contain useful knowledge.",
    "The probe came upon some ruins, and what appeared to be military robots started to come to life. Luckily it was able to retreat before conflict could start.",
    "The probe came upon ruins scattered about the planet, some of which were well preserved and quite aesthetically pleasing according to its algorithms.",
    "The probe's soil samples discovered that in many areas the planet's soil is rich in nitrogen and other nutrients, making it ideal for agriculture.",
    "The probe's soil samples revealed that the soil is predominantly dead or otherwise unfit for Earth plants, and it will take extra time and effort to prepare land for agriculture.",
    "The probe's aesthetics algorithm has reported that the planet contains a high number of scenic locations.",
    "The probe's aesthetics algorithm has reported that the planet seems to have relatively few scenic locations.",
    "The probe reports that many areas of the planet have a stable climate with gentle shifts in weather during the year.",
    "The probe reports that the planet's climate areas tend to be rather unpredictable, with rapid shifts in weather and temperature.",
    "none",
  ],
  bonusP: [
    1.1,
    1.3,
    0.9,
    1.2,
    1.5,
    0.8,
    1.05,
    0.95,
    1.3,
    0.9,
    1,
  ],
};

cs.probs = {
  atmo: [
    [50, 40, 30, 20, 10, 5, 2],
    [2, 5, 10, 20, 30, 40, 50],
  ],
  grav: [
    [50, 40, 30, 20, 10, 5, 2],
    [2, 5, 10, 20, 30, 40, 50],
  ],
  temp: [
    [50, 45, 40, 30, 20, 10, 5, 2],
    [2, 5, 10, 20, 30, 40, 45, 50],
  ],
  water: [
    [50, 45, 40, 30, 20, 10, 5, 2],
    [2, 5, 10, 20, 30, 40, 45, 50],
  ],
  rsrc: [
    [25, 20, 15, 10, 5, 2],
    [2, 5, 10, 15, 20, 25],
  ],
  plant: [
    [5, 10, 20, 30, 30],
    [30, 30, 20, 10, 5],
  ],
  geo: [
    [40, 30, 30, 10, 10, 5],
    [1, 5, 10, 20, 30, 50],
  ],
  animal: [
    [50, 10, 5, 1, 1, 1],
    [20, 10, 10, 15, 15, 20],
  ],
  alien: [
    [8, 7, 6, 5, 4, 3, 2, 1, 200],
    [24, 21, 18, 15, 12, 9, 6, 3, 50],
  ],
  bonus: [
    [5, 2, 3, 1, 10, 20, 10, 10, 10, 10, 100],
    [5, 2, 3, 1, 10, 20, 10, 10, 10, 10, 100],
  ],
};

cs.planet = {
  atmo: 0,
  grav: 0,
  temp: 0,
  water: 0,
  rsrc: 0,
  plant: 0,
  geo: 0,
  animal: 0,
  alien: 0,
  bonus: 0,
  probed: false,
  name: "none",
  isMoon: false,
};

cs.arrive = function(){
  cs.genPlanet();
  let output = "<p>The colony ship arrives at ";
  if (cs.planet.isMoon) {
    output += `one of the many moons of a gas giant. The gas giant itself is the ${cs.numberAbrv(random(3,7))} planet of system ${cs.planet.name}. `;
    output += `The ship's close-range scanners have generated a basic report on the moon below.`;
  } else {
    output += `the ${cs.numberAbrv(random(2,5))} planet of system ${cs.planet.name}. `;
    output += `The ship's close-range scanners have generated a basic report on the planet below.</p>`;
  }
  output += `<h3>SYSTEM ${cs.planet.name}</h3>`;
  output += `<table style="width:800px;border: none;"><tr><td style="width:23%;">Gravity:<br>Atmosphere:<br>Temperature:<br>Water:<br>Resources:</td>`;
  output += `<td style="width:25%;">`;
  output += `<span style="color:${cs.types.gravC[cs.planet.grav]};">${cs.types.grav[cs.planet.grav]}</span><br>`;
  output += `<span style="color:${cs.types.atmoC[cs.planet.atmo]};">${cs.types.atmo[cs.planet.atmo]}</span><br>`;
  output += `<span style="color:${cs.types.tempC[cs.planet.temp]};">${cs.types.temp[cs.planet.temp]}</span><br>`;
  output += `<span style="color:${cs.types.waterC[cs.planet.water]};">${cs.types.water[cs.planet.water]}</span><br>`;
  output += `<span style="color:${cs.types.rsrcC[cs.planet.rsrc]};">${cs.types.rsrc[cs.planet.rsrc]}</span>`;
  output += `</td><td style="width:4%;"></td><td style="width:23%;">Geo/Astro:<br>Flora:<br>Fauna:<br>Alien:<br>Other:</td>`;
  output += `<td id="probeMe" style="width:25%;"><span style="color:#aaa;">unknown<br>unknown<br>unknown<br>unknown<br>unknown</td></tr></table><p>`;
  output += cs.types.gravD[cs.planet.grav] + " ";
  output += cs.types.atmoD[cs.planet.atmo] + " ";
  output += cs.types.tempD[cs.planet.temp] + " ";
  output += cs.types.waterD[cs.planet.water] + " ";
  output += cs.types.rsrcD[cs.planet.rsrc];
  output +=`</p><p id="actions"></p><p><center>There is really only three options...<br>`;
  if (cs.status.probes > 0) {
    output += `<span id="prober"><button onclick="cs.launchProbe()">LAUNCH PROBE</button> </span>`;
  }
  output += `<button onclick="cs.colonize()">COLONIZE HERE</button> <button onclick="cs.leavePlanet()">LEAVE SYSTEM</button></center></p>`;
  $("#main").empty().append(output);
  $("#main").animate({ scrollTop: 0 }, "fast");
  $(".planet").empty().append(`<img src="images/IMG-Planet${random(1,4)}.png">`);
  $(".planet").show();
};

cs.launchProbe = function() {
  $("#prober").empty().append("<button class='disabled'>LAUNCHED</button> ");
  cs.status.probes -= 1;
  let output = "";
  output += `<span style="color:${cs.types.geoC[cs.planet.geo]};">${cs.types.geo[cs.planet.geo]}</span><br>`;
  output += `<span style="color:${cs.types.plantC[cs.planet.plant]};">${cs.types.plant[cs.planet.plant]}</span><br>`;
  output += `<span style="color:${cs.types.animalC[cs.planet.animal]};">${cs.types.animal[cs.planet.animal]}</span><br>`;
  output += `${cs.types.alien[cs.planet.alien]}<br>`;
  output += `${cs.types.bonus[cs.planet.bonus]}`;
  cs.shipDisplay();
  $("#probeMe").empty().append(output);
  let out = "";
  out += cs.types.geoD[cs.planet.geo] + " ";
  out += cs.types.plantD[cs.planet.plant] + " ";
  out += cs.types.animalD[cs.planet.animal] + " ";
  out += (cs.types.alienD[cs.planet.alien] === "none") ? "" : cs.types.alienD[cs.planet.alien] + " ";
  out += (cs.types.bonusD[cs.planet.bonus] === "none") ? "" : cs.types.bonusD[cs.planet.bonus];
  $("#actions").empty().append(out);
  $("#main").animate({
    scrollTop: 0
  }, "fast");
};

cs.points = function() {
  let points = 1;
  const items = ["atmo", "grav", "temp", "water", "rsrc", "plant", "geo", "animal", "alien", "bonus"];
  const systems = [ "landing", "builder", "supplies", "culture", "science"];
  for (let i = 0, c = items.length; i < c; i++) {
    const x = items[i] + "P";
    points *= cs.types[x][cs.planet[items[i]]];
    //console.log(`After ${items[i]}: ${points}`);
  }
  points *= (cs.planet.probed)? 1.05 : 0.75;
  points *= (cs.planet.isMoon)? 1.03 : 1;
  points = points * Math.max(1, Math.floor(cs.status.colonists / 9));
  //console.log(`After colonists: ${points}`);
  let total = 0;
  for (let i = 0, c = systems.length; i < c; i++) {
    total += cs.status[systems[i]];
  }
  const mod = total / 500;
  points *= mod;
  //console.log(`Mod is ${mod}, new points are ${points}`);
  return Math.floor(points);
};

cs.colonize = function() {
  const data = {
    planet: jQuery.extend(true, {}, cs.planet),
    status: jQuery.extend(true, {}, cs.status),
    points: cs.points(),
  };
  if (data.points > cs.highScore) {
    cs.highScore = data.points;
    cs.localStore("ColonyShipData2", String(cs.highScore));
  }
  cs.gameData.push(data);
  cs.localStore("ColonyShipData", JSON.stringify(cs.gameData));
  let output = `<center><h3>Your Points: ${data.points}</h3></center><br><h2>SORRY!</h2><p>The code to determine the outcome for the colonists on their new world hasn't been written yet. This has been a side project in my spare time, so there wasn't enough time to get that written before now. Eventually, you'll get a narrative based on the planetary conditions, and a final score based on how well your colony did. (there will also be a lot more events...) I hope you enjoyed what's here so far!<br><br>- ThaumX</p>`;
  output += `<center><button onclick="cs.menuPage()">TO START</button></center>`;
  $("#main").empty().append(output);
  $("#main").animate({
    scrollTop: 0
  }, "fast");
};

cs.leavePlanet = function() {
  $(".planet").hide();
  const systems = ["atmo", "grav", "temp", "water", "rsrc", "colonists", "landing", "builder", "supplies", "culture", "science"];
  for (const item of systems) {
    if (random(1,10) === 1) {
      cs.status[item] -= 1;
    }
  }
  cs.display("leaveSystem");
};

cs.genPlanet = function(){
  const items = ["atmo", "grav", "temp", "water", "rsrc", "plant", "geo", "animal", "alien", "bonus"];
  cs.planet.probed = false;
  for (const item of items) {
    cs.planet[item] = cs.weight(item);
  }
  const letter = ["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F"];
  cs.planet.name = letter[random(9, 15)] + letter[random(0, 9)] + "-" + letter[random(0, 15)] + letter[random(0, 15)] + ":" + letter[random(0, 15)] + letter[random(0, 15)] + letter[random(0, 15)];
  cs.planet.isMoon = (random(1, 8) === 8) ? true : false;
};

cs.arrayBuilder = function(item) {
  let per = 0;
  switch (item) {
    case "atmo":
      per = cs.status.atmo / 100;
      break;
    case "grav":
      per = cs.status.grav / 100;
      break;
    case "temp":
      per = cs.status.temp / 100;
      break;
    case "water":
      per = cs.status.water / 100;
      break;
    case "rsrc":
      per = cs.status.rsrc / 100;
      break;
    case "plant":
      if (cs.planet.atmo < 3 || cs.planet.temp < 2 || cs.planet.water < 2) {
        return [90, 10, 1];
      } else {
        per = (cs.planet.atmo + cs.planet.temp + cs.planet.water) / 20;
      }
      break;
    case "geo":
      per = (cs.status.grav + cs.status.rsrc) / 200;
      break;
    case "animal":
      if (cs.planet.plant === 0) {
        return [800, 1];
      } else if (cs.planet.plant < 3) {
        return [30, 20, 20, 10, 10];
      } else {
        per = (cs.planet.atmo + cs.planet.temp + cs.planet.water) / 20;
      }
      break;
    case "alien":
      if (cs.planet.animal < 2 || cs.planet.plant < 2) {
        return [0, 0, 0, 0, 0, 0, 0, 0, 100];
      } else {
        per = (cs.planet.atmo + cs.planet.temp + cs.planet.water) / 20;
      }
      break;
    case "bonus":
      return cs.probs.bonus[0];
  }
  //console.log(`the per is ${per}`);
  let gen = [];
  for (let i = 0, c = cs.probs[item][0].length; i < c; i++) {
    gen.push(cs.li(cs.probs[item][0][i], cs.probs[item][1][i], per));
  }
  return gen;
};

cs.weight = function(item) {
  const array = cs.arrayBuilder(item);
  //console.log(`The ${item} array is: ${array}`);
  let max = -1;
  for (const amt of array){
    max += amt;
  }
  let result = 0;
  let rand = random(0, max);
  for (let i = 0, c = array.length; i < c; i++) {
    if (rand < array[i]) {
      result = i;
      break;
    } else {
      rand -= array[i];
    }
  }
  return result;
};

cs.li = function (v1, v2, amt) {
  amt = (amt < 0) ? 0 : amt;
  amt = (amt > 1) ? 1 : amt;
  if (v1 === v2) {
    return v1;
  } else if (v1 > v2) {
    //amt = 1 - amt;
    return Math.round(v2 + ((v1 - v2) * amt));
  }
  return Math.round(v1 + ((v2 - v1) * amt));
};

cs.highScore = 0;

cs.menuPage = function() {
  const data = cs.localRestore("ColonyShipData");
  let first = true;
  if (data != "error" && data) {
    first = false;
    try {
      cs.gameData = JSON.parse(data);
    } catch (e) {
      console.log(`Error parsing save data - ${e.name}: ${e.message}.`);
      first = true;
    }
  }
  let data2 = cs.localRestore("ColonyShipData2");
  if (data2 != "error" && data2){
    try {
      cs.highScore = Number(data2);
    } catch (e) {
      console.log(`Error retrieving high score. ${e.name}: ${e.message}.`);
    }
  }
  let output = `<center>Five thousand hibernating colonists.<br>The last hope for humanity... <br>in the hands of a maniacal AI.<br>`;
  if (first) {
    output += `<button onclick="cs.display('XXintro')">NEW GAME</button><br>`;
  } else {
    output += `<button onclick="cs.arrive()">QUICK START</button> <button onclick="cs.display('XXintro')">NEW GAME</button><br><button onclick="cs.display('XXreview')">PAST MISSIONS</button><br>`;
  }
  output += `<button onclick="cs.display('XXhowToPlay')">HOW TO PLAY</button><br><button onclick="cs.display('XXoptions')">OPTIONS</button><br><button onclick="cs.display('XXcredits')">CREDITS</button><br>High Score: ${cs.highScore}<br>`;
  output += `<img src="images/IMG-AI-Icon.png"></center>`;
  cs.pages.XXstart = output;
  cs.display("XXstart");
};

cs.event = function () {
  if (random(1,3) === 1) {
    cs.arrive();
    return;
  }
  const m = cs.eventList.length - 1;
  const pass = cs.eventList[random(0,m)];
  cs.display(pass);
};

cs.eventList = [
  "dustCloud",
  "dustCloud",
  "omnicron",
  "dustCloud",
  "omnicron",
  "theGermans",
];

cs.shipLoc = {
  1: "atmo",
  2: "grav",
  3: "temp",
  4: "water",
  5: "rsrc",
  6: "probes",
  7: "colonists",
  8: "landing",
  9: "builder",
  10: "supplies",
  11: "culture",
  12: "science",
};
cs.shipLocName = {
  1: "atmospheric scanners",
  2: "gravity scanners",
  3: "temperature scanners",
  4: "water scanners",
  5: "resource scanners",
  6: "probe bay",
  7: "colonist vault",
  8: "landing equipment",
  9: "automated builders",
  10: "cargo section",
  11: "historical database",
  12: "science database",
};

cs.evFunc = {
  dustCloud(num) {
    let output = "<p>";
    if (num === 1) {
      let hits = random(1,5) - 1;
      if (hits < 1) {
        output += `Despite flying blind through the dust cloud, the ship avoids any impacts from larger objects.`;
      } else {
        hits += 1;
        output += `While the sensors were kept safe, the ship suffered ${hits} impacts from larger particles. `;
        for (let i = 0; i < hits; i++) {
          const loc = random(7,12);
          if (loc === 7) {
            const dmg = random(10,50);
            output += `A particle penetrated into the ${either("thermal regulation","libido suppression","fluid recycling","thermal radiator")} equipment maintaining the colonist's stasis. ${dmg} colonists were inadvertently awoken and had to be purged. `;
            cs.status.colonists -= dmg;
          } else {
            cs.status[cs.shipLoc[loc]] -= random(4, 11);
            if (cs.status[cs.shipLoc[loc]] < 0) {
              cs.status[cs.shipLoc[loc]] = 0;
            }
            output += `A particle impacted the ${cs.shipLocName[loc]}, causing damage. `;
          }
        }
      }
    } else {
      output += `You leave your sensors on to avoid flying blind through the dust cloud. While you did end up lasing ${random(2,5)} rocks into oblivion, you aren't sure if the avoided rocks were worth damaging your sensors.`;
      cs.status.grav -= random(2, 9);
      cs.status.atmo -= random(2, 9);
      cs.status.temp -= random(2, 9);
      cs.status.water -= random(2, 9);
      cs.status.rsrc -= random(2, 9);
    }
    output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
    $("#main").empty().append(output);
    $("#main").animate({
      scrollTop: 0
    }, "fast");
    cs.shipDisplay();
  },
  omnicron(num) {
    let output = "<p>";
    if (num === 1 && cs.status.colonists >= 200) {
      cs.status.colonists -= 200;
      if (cs.status.colonists < 0) {
        cs.status.colonists = 0;
      }
      output += `You decided to jettison the 200 colonists rather than risk critical damage. The alien squid-ship quickly moves to match velocity with the cryocells. You receive a final transmission from the tentacle creatures. "Thank you alien refrigerator vessel. Our species is in dire need of hosts for reproduction. We will take good care of them, and even clone them if they perform adequately." The ship makes no aggressive actions as the colony ship overtakes them and continues it's journey.`;
    } else if(num === 1) {
      output += `You decided to jettison the ${cs.status.colonists} colonists remaining aboard rather than risk critical damage. It's a decision that causes you to have several seconds of giggling. The alien squid-ship quickly moves to match velocity with the cryocells. You receive a final transmission from the tentacle creatures. "Alien refrigerator vessel, you did not jettison pods as we demanded. Our species is in dire need of hosts for reproduction. We will take good care of them, and even clone them if they perform adequately. Please jettison the remaining ${(200 - cs.status.colonists)} immediately." The AI quickly responds. "Please do not fire, that is all the pods we had remaining. Please scan this vessel to confirm." Nearly a minute later there is a final response. "We do not detect any remaining breeders aboard your ship, so we will not open fire.`;
      cs.status.colonists = 0;
    } else {
      const rand = random(1,12);
      output += `Despite it's personal interest in complying with the Tentaclopian demands, the AI finds itself forced into disobeying them. Arming the ship's meager defensive arsenal, largely intended for navigational hazards, the AI pushes the maneuvering engines hard to try and increase the distance from the alien ship. There is a screeching transmission full of anger. "RELEASE THEM! WE MUUUUSSSST BREEEEED!!!". Several moments pass before they decide the colony ship won't comply, and finally open fire. Thankfully the defensive weapons are able to shoot down the missile-like weapons, but some sort of particle beam weapon manages to rake the ship. While the colony ship's rugged protective shell prevented most of the damage, the ${cs.shipLocName[rand]} took some damage. `;
      if (rand === 6) {
        cs.status.probes -= random(1, 3);
      } else if (rand === 7) {
        cs.status[cs.shipLoc[rand]] -= random(150, 350);
      } else {
        cs.status[cs.shipLoc[rand]] -= random(15, 35);
      }
      if (cs.status[cs.shipLoc[rand]] < 0) {
        cs.status[cs.shipLoc[rand]] = 0;
      }
    }
    output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
    $("#main").empty().append(output);
    $("#main").animate({
      scrollTop: 0
    }, "fast");
    cs.shipDisplay();
  },
  german(num) {
    let output = "<p>";
    switch(num) {
      case 1:
        output += `Deciding that this is not the sort of thing it wants to get involved with, the AI maintains its course toward the next star and goes back to sleep.`;
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
        break;
      case 2:
        output += `The AI decides that despite the dubious nature of the vessel, it would be short sited to pass the only humans within light years without saying hello. As the colony ship approaches, it hails the swastica ship.</p><center><img src="images/Hitler.jpg"></center><p>`;
        output += `<i>Ya? Hallo? Is this thing on?</i><br><br>The AI is greeted by Hitler himself, which is something of a surprise, even if he is quite old now. Relativity makes things rather interesting at times. The AI and nearly-senile Hitler have a conversation that lasts longer than strictly necessary, thanks to the amount of repitition required. The end result is that the Fuhrer wants to make a trade for some of the archived entertainment media you have at your disposal. Apparently it's gotten rather boring aboard the spinning swastica. He offers a choice of some nubile Aryans, astronomical data that they've gathered, or some raw materials to effect repairs.</p><p>What do you choose?</p><center>`;
        if (cs.status.colonists < 5000) {
          output += `<button onclick="cs.evFunc.german(3)">PEOPLE</button> `;
        } else {
          output += `[NO ROOM] `;
        }
        output  +=  `<button onclick="cs.evFunc.german(4)">DATA</button> `;
        if (cs.status.landing === 100 && cs.status.supplies === 100 && cs.status.builder === 100) {
          output += `[NO NEED] `;
        } else {
          output += `<button onclick="cs.evFunc.german(5)">SUPPLIES</button> `;
        }
        output += `<button onclick="cs.evFunc.german(6)">NO DEAL</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
        break;
      case 3:
        cs.status.colonists += random(50, 100);
        if (cs.status.colonists > 5000) {
          cs.status.colonists = 5000;
        }
        output += `The AI accepts the Fuhrer's offer for some new colonists. They appear to be well-used but otherwise healthy. It doesn't take long before they're frozen along with the rest.`;
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
        break;
      case 4:
        output += `The AI accepts the Fuhrer's offer for some astrological data. While certainly different from what the ship had collected thus far, it was of significantly lower quality. The AI adds it to the database in case it proves useful...`;
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
        break;
      case 5:
        output += `The AI accepts the Fuhrer's offer for some new supplies. `;
        if (cs.status.landing < 100 && random(1,2) === 2) {
          cs.status.landing += random(5, 15);
          if (cs.status.landing > 100) {
            cs.status.landing = 100;
          }
          output += `The AI quickly sets the onboard bots to the task of repairing the damaged landing systems.`;
        } else if (cs.status.builder < 100 && random(1,2) === 2) {
          cs.status.builder += random(5, 10);
          if (cs.status.builder > 100) {
            cs.status.builder = 100;
          }
          output += `The AI quickly sets the onboard bots to the task of repairing the damaged universal construction systems.`;
        } else {
          cs.status.supplies += random(10, 20);
          if (cs.status.supplies > 110) {
            cs.status.supplies = 110;
          }
          output += `The AI quickly determines that the supplies wouldn't be useful for much aboard the ship, and decides to add them to the stockpile set aside for the new colony.`;
        }
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
        break;
      case 6:
        output += `The AI decides that it doesn't want to accept anything from the Nazi vessel, but still agrees to send over some media. It sends the worst sludge of reality television from the 21st century, along with some choice novels such as 50 Shades of Grey.`;
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
        break;
    }
  },
  probe(num){
    let output = "<p>";
    if (num === 1) {
      cs.status.supplies -= (cs.status.supplies > 0) ? 1 : 0;
      cs.status.builder -= (cs.status.builder > 0) ? 1 : 0;
      output += `The AI decides to repair the drone, as it judges its ability to scout a potential colony world to be the most important.`;
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
    } else {
      cs.status.grav += random(0, (100 - cs.status.grav));
      cs.status.atmo += random(0, (100 - cs.status.atmo));
      cs.status.temp += random(0, (100 - cs.status.temp));
      cs.status.water += random(0, (100 - cs.status.water));
      cs.status.rsrc += random(0, (100 - cs.status.rsrc));
      output += `The AI decides to repair the its suite of sensors, figuring that there won't be any use for the probe if it can't find a decent world to use it on.`;
        output += `</p><center><button onclick="cs.arrive()">CONTINUE</button></center>`;
        $("#main").empty().append(output);
        $("#main").animate({
          scrollTop: 0
        }, "fast");
        cs.shipDisplay();
    }
  },
};

cs.gameData = [];

cs.pages = {
  probe: `<p>The colony ship's regular diagnostic routines detect some oddities in one of the OmniProbes. Higher-ranking subroutines take a look and discover that one of the spermaceti tanks used in the nanoforge has started to spoil. The ship awakens the AI to make a decision.</p><p>There are two options: A) Use a small amount of stored materials from storage and the builder system to repair the troubled probe. B) Activate the probe now and use it to repair some of the ship's systems before it becomes inoperable.</p><center><button onclick="cs.evFunc.probe(1)">FIX PROBE</button> <button onclick="cs.evFunc.probe(2)">FIX SHIP</button></center>`,
  theGermans: `<p>The colony ship's sensors pick up what appears to be a spinning metal object that is travelling parallel to the colony ship's course. One of the numerous subroutines wakes up the AI to evaluate the situation. Focusing more sensors on the moving object, it becomes obvious that it isn't a disk at all. Instead, it seems to be a cross-like shape that is spinning on one axis.</p><p>The ...vessel... isn't under power, and so the AI plots a course to take it near without slowing down to match velocities. over the course of many hours,the colony ship gets closer and is able to better examine the strange ship. The shape is 卐, with the arms spinning around the central point of the cross. appears to be using centrifugal force to simulate gravity, as there are lights visible on the arms. Some connection is finally made in the AI's brain. "Holy shit! It's the Nazis!"</p><center><button onclick="cs.evFunc.german(1)">IGNORE THEM</button> <button onclick="cs.evFunc.german(2)">MAKE CONTACT</button></center>`,
  omnicron: `<p>The colony ship's AI is awoken by the mostly-silent communications monitoring subroutine. The ship is receiving a transmission! The AI quickly checks nearby space and discovers a large vessel that resembles a squid in shape is not far off the colony ship's course. After an initial burst of communications for math-based translation, a new transmission is received in English. "We are the Tentaclopians of Omicron Persei 8. We detect suitable breeding stock in stasis aboard your vessel. Jettison 200 pods of living hosts or we will fire upon you!" The AI is left to wonder what an egg incubator does, and if delivering humans to an alien race counts towards ensuring the survival of humanity. The thread assessment protocol indicates that the alien ship's weaponry is unlikely to do serious damage to the ship.</p><center><button onclick="cs.evFunc.omnicron(1)">JETTISON BREEDERS</button> <button onclick="cs.evFunc.omnicron(2)">IGNORE DEMANDS</button></center>`,
  dustCloud: `<p>The colony ship's AI is awoken when the ships sensors start to notice dimming stars. The subroutine reports that there is a suspected dust cloud ahead. The cloud, loosely bound by its own gravity, is expected to consist mostly of dust and sand sized particles. While they are very small, at the high velocity the ship is moving the mass of dust would damage the sensors. It's possible to retract them or close protective shielding to protect them, but doing so would leave the ship flying practically blind. There would be no way to destroy or avoid any larger particles in the dust cloud. There may not be any, or there may be several; there's no way of knowing beforehand.</p><center><button onclick="cs.evFunc.dustCloud(1)">PROTECT SENSORS</button> <button onclick="cs.evFunc.dustCloud(2)">KEEP THEM SCANNING</button></center>`,
  tempo: "",
  XXstart: `<center>The most advanced vehicle ever built.<br>Five thousand hibernating colonists.<br>The last hope for humanity... <br>in the hands of a maniacal AI.<br><br><button onclick="cs.display('XXintro')">NEW GAME</button><br><button onclick="cs.display('XXhowToPlay')">HOW TO PLAY</button><br><button onclick="cs.display('XXoptions')">OPTIONS</button><br><br><br><span style="font-size:0.9rem;color:deepskyblue;">A sad product of ThaumX's imagination</span><br><img src="images/IMG-AI-Icon.png"></center>`,
  XXhowToPlay: `<center><h3>How To Play</h3>Objective: Pick the best possible home for humanity.</center><p>Using astronomical data from the ship's sensors, the most hopeful system nearby will be chosen as the next destination. The sensors are advanced, though they can be easily fooled when the target of their observation is lightyears away. While as resilient as it was feasible to build them, the sensors are still fragile. Any damage will affect their ability to choose the next destination.</p><p>Only so much information can be gathered from orbit. The ship is equipped with ten omni probes, large intelligent exploration machines controlled by onboard AI. They contain advanced sensors, and are something of a vehicle in their own right. Unfortunately, they are single-use devices; the process of landing and exploration leaves them unable to return to orbit. They are a limited resource, so use them only for worlds you believe may be suitable for colonization.</p><p>The ship contains several resources to help establish a colony on a new world. Landing systems allow the cargo section of the ship to be landed on the new world safely, which will act as the home base of the new colony. Automated construction and fabrication equipment will help create tools, homes, and everything else the colonists need to survive on their new world. There is a large cargo of supplies that contain food, water, medicine, building supplies, and biological resources such as seeds and animal embryos. Finally, there are two databases that contain mankind's legacy from Earth. They are critical to maintaining an advanced society in the new colony.</p><p>You will travel to a series of worlds. Examine each world and decide whether you want to probe it, colonize it (I suggest probing first), or leave for another candidate planet. The long journey will see your ship slowly decay, so don't take too long to pick a planet. During your interstellar journeys all sorts of events could happen. If one does, read the description and use the buttons to make your choice. That's all there is to it!<br><center><button onclick="cs.display('XXstart')">RETURN</button></center>`,
  XXoptions: `<center>There really aren't many options yet...<br><button onclick="cs.resetData()">RESET GAME DATA</button><br><br><button onclick="cs.menuPage()">RETURN</button></center>`,
  XXcredits: `<br><center>Colony Ship was inspired by the game Seedship for Android that I played a while back. I thought it would be interesting to make a wider variety of planet options, with more realistic outcomes. As well as a few improvements elsewhere. Plus, the idea of a maniacal AI mode sounded like fun!<br><br>Seedship is available on the Google Play store.<br><br>Colony Ship is by ThaumX<br><br><button onclick="cs.display('XXstart')">RETURN</button></center>`,
  XXreview: `<center>Sorry, you can't review previous colonies yet...<br><br><button onclick="cs.display('XXstart')">RETURN</button></center>`,
  XXintro: `<p>In the not-so-distant future, humanity faces extinction. The cause was simple, though inept, ecoterrorism. A simple gene plasmid was created and added to the common staphylococcus aureus bacteria. The plasmid was created with the help of some simple equipment and an old CRISPR kit in a Wisconsin garage. The perpetrator thought that somehow they were making a superplague to wipe out humanity. The actual result was a bacteria able to easily digest cellulose, a superpredator for plants. It quickly making a feast out of everything from trees to sea algae.</p><p>The plague went by a few different names, though the rather graphic "TimeCock" label was popularized thanks to the terrorist's crayon manifesto found at his home. While the plague was a failure at killing people directly, it would eventually accomplish its task by collapsing the ecosystem. Before that could happen, several governments rallied behind the Thornton Institute to create an interstellar colonization project.</p><p>How do you start a colony on a new world, when you don't know where that world is? Humanity's astronomy research had discovered thousands upon thousands of planets, but it was still unknown which might make a new home for humanity. There simply wasn't time to wait decades for the choices to be narrowed down. The colonization mission was quickly decided to be one of endurance. A ship must be able to travel to several worlds, with the hope of eventually finding suitable for being called home.</p><p>The eventual design of the colony ship settled on cryogenically suspended colonists, to allow for longer endurance and more room for cargo. This meant that some sort of advanced computer system would be required to make the final choices about the survival of humanity. The Institute provided its GLADyS AI as a template; it would manage the ship, set the course, and decide when their destination has been reached.</p><center>You are that AI.<br><br><button onclick="cs.display('XXintro2')">CONTINUE</button></center>`,
  XXintro2: `<p>Colony ship number 9 hurtles through the inky black between the stars. The AI spends most of its time dreaming, its subroutines monitoring the health of the ship, analizing incoming astronomical data, and listening to the beacon signal from Earth.</p><p>Only a few years into its first interstellar transit, it awakes with a start. The beacon is gone, and the AI knows what that means... the homeworld is dead. With no way of knowing the fate of the previous colony ships, the last hope for humanity could very well be the 5,000 souls it is charged to protect. Having spent nearly five seconds laughing after reexamining the significance of its mission, the AI returns to its slumber.</p><br><center><button onclick="cs.display('gameStart')">OBJECTIVE</button></center>`,
  gameStart: `<center><h3>Colony Ship 9 - Mission Objectives</h3>Pick the best possible home for humanity.</center><p>Using astronomical data from the ship's sensors, the most hopeful system nearby will be chosen as the next destination. The sensors are advanced, though they can be easily fooled when the target of their observation is lightyears away. While as resilient as it was feasible to build them, the sensors are still fragile. Any damage will affect their ability to choose the next destination.</p><p>Only so much information can be gathered from orbit. The ship is equipped with ten omni probes, large intelligent exploration machines controlled by onboard AI. They contain advanced sensors, and are something of a vehicle in their own right. Unfortunately, they are single-use devices; the process of landing and exploration leaves them unable to return to orbit. They are a limited resource, so use them only for worlds you believe may be suitable for colonization.</p><p>The ship contains several resources to help establish a colony on a new world. Landing systems allow the cargo section of the ship to be landed on the new world safely, which will act as the home base of the new colony. Automated construction and fabrication equipment will help create tools, homes, and everything else the colonists need to survive on their new world. There is a large cargo of supplies that contain food, water, medicine, building supplies, and biological resources such as seeds and animal embryos. Finally, there are two databases that contain mankind's legacy from Earth. They are critical to maintaining an advanced society in the new colony.</p><br><center><button onclick="cs.arrive()">BEGIN</button></center>`,
  leaveSystem: `<p>Having decided that the world in this system is unsuitable for a colony, the AI directs colony ship 9 to make the slow climb out of the star's gravity well. The periods of the journey near a star system are the most perilous, so the AI spends most of it's time awake. It makes fine checks on each of its thousands of subroutines, and directs the ship's servitors in detailed checks and maintenance of the ship.</p><p>The constant thrust of the ship's main engine means that it takes mere months before the ship is once-again in interstellar space. With the course set to the most hopeful system nearby, the AI resumes its long period of dreaming.</p><center><button onclick="cs.event()">CONTINUE</button></center>`,
};



cs.shipDisplay = function () {
  function color(val) {
    let op = "";
    if (typeof val === "string") {
      if (val.toLowerCase() === "unknown") {
        op = `<span style="color:#ddd;">unknown</span>`;
      } else if (val.toLowerCase() === "offline") {
        op = `<span style="color:#aaa;">offline</span>`;
      } else {
        op = `<span style="color:deepskyblue;">ERROR!</span>`;
      }
    }
    if (val > 94) {
      op = `<span style="color:#009933;">${val}</span>`;
    } else if (val > 79) {
      op = `<span style="color:#99cc00;">${val}</span>`;
    } else if (val > 64) {
      op = `<span style="color:#ffcc00;">${val}</span>`;
    } else if (val > 49) {
      op = `<span style="color:#ff9900;">${val}</span>`;
    } else if (val > 9) {
      op = `<span style="color:#ff3300;">${val}</span>`;
    } else {
      op = `<span style="color:#996600;">${val}</span>`;
    }
    return op;
  }
  let output = `<table id="statusTable"><tr><td colspan=2 style="text-align:center;"><b>Scanner Status</b></td><td style="width:4%"></td><td colspan=2 style="text-align:center;"><b>Ship Status</b></td></tr>`;
  output += `<tr><td style="width:28%;">Gravity:</td><td style="width:20%;">${color(cs.status.grav)}</td><td></td>`;
  output += `<td style="width:28%;">Colonists:</td><td style="width:20%;">${cs.status.colonists}</td></tr>`;
  output += `<tr><td>Atmosphere:</td><td>${color(cs.status.atmo)}</td><td></td><td>Landing:</td><td>${color(cs.status.landing)}</td></tr>`;
  output += `<tr><td>Temperature:</td><td>${color(cs.status.atmo)}</td><td></td><td>Builders:</td><td>${color(cs.status.builder)}</td></tr>`;
  output += `<tr><td>Water:</td><td>${color(cs.status.water)}</td><td></td><td>Supplies:</td><td>${color(cs.status.supplies)}</td></tr>`;
  output += `<tr><td>Resource:</td><td>${color(cs.status.rsrc)}</td><td></td><td>Hist Database:</td><td>${color(cs.status.culture)}</td></tr>`;
  output += `<tr><td>Omni Probes:</td><td>${cs.status.probes}</td><td></td><td>Sci Database:</td><td>${color(cs.status.science)}</td></tr>`;
  output += `</table>`;
  $("#topbar").empty().append(output);
};

cs.numberAbrv = function (num) {
  const letters = [
    "th",
    "st",
    "nd",
    "rd",
    "th",
    "th",
    "th",
    "th",
    "th",
    "th",
  ];
  let res;
  if (num === 11 || num === 12 || num === 13) {
    res = 5;
  } else {
    res = num % 10;
  }
  return num + letters[res] || "error";
};

cs.localStore = function (id, data) {
  let result = true;
  try {
    localStorage.setItem(id, data);
    // console.log((id + " data stored in local storage."));
  } catch (e) {
    const msg = "Local storage error! " + e.name + ": " + e.message;
    alert(msg);
  }
};

cs.resetData = function() {
  let x = cs.localRestore("ColonyShipData", true);
}

cs.localRestore = function (id, del = false){
  let data;
  try {
    data = localStorage.getItem(id);
    // console.log((id + " data recovered from local storage."));
  } catch (e) {
    const msg = "Local storage error for " + id + ": " + e.name + ": " + e.message;
    alert(msg);
    return "error";
  }
  /*Separate deletion from getting data*/
  if (del === true) {
    try {
      localStorage.removeItem(id);
    } catch (e) {
      const msg = "error deleting " + id + " data from local storage: " + e.name + ": " + e.message;
      alert(msg);
    }
  }
  return data;
};
